// source: byhiras/delta/json_patch.proto
/**
 * @fileoverview
 * @enhanceable
 * @suppress {missingRequire} reports error on implicit type usages.
 * @suppress {messageConventions} JS Compiler reports an error if a variable or
 *     field starts with 'MSG_' and isn't a translatable message.
 * @public
 */
// GENERATED CODE -- DO NOT EDIT!
/* eslint-disable */
// @ts-nocheck

var jspb = require('google-protobuf');
var goog = jspb;
var global = (function() {
  if (this) { return this; }
  if (typeof window !== 'undefined') { return window; }
  if (typeof global !== 'undefined') { return global; }
  if (typeof self !== 'undefined') { return self; }
  return Function('return this')();
}.call(null));

var byhiras_identity_identity_pb = require('../../byhiras/identity/identity_pb.js');
goog.object.extend(proto, byhiras_identity_identity_pb);
var google_protobuf_wrappers_pb = require('google-protobuf/google/protobuf/wrappers_pb.js');
goog.object.extend(proto, google_protobuf_wrappers_pb);
goog.exportSymbol('proto.byhiras.delta.JsonPatchOp', null, global);
goog.exportSymbol('proto.byhiras.delta.JsonPatchRequest', null, global);
goog.exportSymbol('proto.byhiras.delta.Op', null, global);
goog.exportSymbol('proto.byhiras.delta.PatchEvent', null, global);
goog.exportSymbol('proto.byhiras.delta.PatchEventRequest', null, global);
goog.exportSymbol('proto.byhiras.delta.PatchEventRequest.TargetCase', null, global);
goog.exportSymbol('proto.byhiras.delta.Value', null, global);
goog.exportSymbol('proto.byhiras.delta.Value.ValueCase', null, global);
goog.exportSymbol('proto.byhiras.delta.ValueList', null, global);
goog.exportSymbol('proto.byhiras.delta.ValueMap', null, global);
/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.byhiras.delta.Value = function(opt_data) {
  jspb.Message.initialize(this, opt_data, 0, -1, null, proto.byhiras.delta.Value.oneofGroups_);
};
goog.inherits(proto.byhiras.delta.Value, jspb.Message);
if (goog.DEBUG && !COMPILED) {
  /**
   * @public
   * @override
   */
  proto.byhiras.delta.Value.displayName = 'proto.byhiras.delta.Value';
}
/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.byhiras.delta.ValueMap = function(opt_data) {
  jspb.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.byhiras.delta.ValueMap, jspb.Message);
if (goog.DEBUG && !COMPILED) {
  /**
   * @public
   * @override
   */
  proto.byhiras.delta.ValueMap.displayName = 'proto.byhiras.delta.ValueMap';
}
/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.byhiras.delta.ValueList = function(opt_data) {
  jspb.Message.initialize(this, opt_data, 0, -1, proto.byhiras.delta.ValueList.repeatedFields_, null);
};
goog.inherits(proto.byhiras.delta.ValueList, jspb.Message);
if (goog.DEBUG && !COMPILED) {
  /**
   * @public
   * @override
   */
  proto.byhiras.delta.ValueList.displayName = 'proto.byhiras.delta.ValueList';
}
/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.byhiras.delta.JsonPatchOp = function(opt_data) {
  jspb.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.byhiras.delta.JsonPatchOp, jspb.Message);
if (goog.DEBUG && !COMPILED) {
  /**
   * @public
   * @override
   */
  proto.byhiras.delta.JsonPatchOp.displayName = 'proto.byhiras.delta.JsonPatchOp';
}
/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.byhiras.delta.PatchEvent = function(opt_data) {
  jspb.Message.initialize(this, opt_data, 0, -1, proto.byhiras.delta.PatchEvent.repeatedFields_, null);
};
goog.inherits(proto.byhiras.delta.PatchEvent, jspb.Message);
if (goog.DEBUG && !COMPILED) {
  /**
   * @public
   * @override
   */
  proto.byhiras.delta.PatchEvent.displayName = 'proto.byhiras.delta.PatchEvent';
}
/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.byhiras.delta.PatchEventRequest = function(opt_data) {
  jspb.Message.initialize(this, opt_data, 0, -1, proto.byhiras.delta.PatchEventRequest.repeatedFields_, proto.byhiras.delta.PatchEventRequest.oneofGroups_);
};
goog.inherits(proto.byhiras.delta.PatchEventRequest, jspb.Message);
if (goog.DEBUG && !COMPILED) {
  /**
   * @public
   * @override
   */
  proto.byhiras.delta.PatchEventRequest.displayName = 'proto.byhiras.delta.PatchEventRequest';
}
/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.byhiras.delta.JsonPatchRequest = function(opt_data) {
  jspb.Message.initialize(this, opt_data, 0, -1, proto.byhiras.delta.JsonPatchRequest.repeatedFields_, null);
};
goog.inherits(proto.byhiras.delta.JsonPatchRequest, jspb.Message);
if (goog.DEBUG && !COMPILED) {
  /**
   * @public
   * @override
   */
  proto.byhiras.delta.JsonPatchRequest.displayName = 'proto.byhiras.delta.JsonPatchRequest';
}

/**
 * Oneof group definitions for this message. Each group defines the field
 * numbers belonging to that group. When of these fields' value is set, all
 * other fields in the group are cleared. During deserialization, if multiple
 * fields are encountered for a group, only the last value seen will be kept.
 * @private {!Array<!Array<number>>}
 * @const
 */
proto.byhiras.delta.Value.oneofGroups_ = [[2,3,4,5,6,7,8,9,10]];

/**
 * @enum {number}
 */
proto.byhiras.delta.Value.ValueCase = {
  VALUE_NOT_SET: 0,
  STRING: 2,
  BOOL: 3,
  INT: 4,
  LONG: 5,
  FLOAT: 6,
  DOUBLE: 7,
  BYTES: 8,
  VALUE_MAP: 9,
  VALUE_LIST: 10
};

/**
 * @return {proto.byhiras.delta.Value.ValueCase}
 */
proto.byhiras.delta.Value.prototype.getValueCase = function() {
  return /** @type {proto.byhiras.delta.Value.ValueCase} */(jspb.Message.computeOneofCase(this, proto.byhiras.delta.Value.oneofGroups_[0]));
};



if (jspb.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * Optional fields that are not set will be set to undefined.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     net/proto2/compiler/js/internal/generator.cc#kKeyword.
 * @param {boolean=} opt_includeInstance Deprecated. whether to include the
 *     JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @return {!Object}
 */
proto.byhiras.delta.Value.prototype.toObject = function(opt_includeInstance) {
  return proto.byhiras.delta.Value.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Deprecated. Whether to include
 *     the JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.byhiras.delta.Value} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.byhiras.delta.Value.toObject = function(includeInstance, msg) {
  var f, obj = {
    string: jspb.Message.getFieldWithDefault(msg, 2, ""),
    bool: jspb.Message.getBooleanFieldWithDefault(msg, 3, false),
    pb_int: jspb.Message.getFieldWithDefault(msg, 4, 0),
    pb_long: jspb.Message.getFieldWithDefault(msg, 5, 0),
    pb_float: jspb.Message.getFloatingPointFieldWithDefault(msg, 6, 0.0),
    pb_double: jspb.Message.getFloatingPointFieldWithDefault(msg, 7, 0.0),
    bytes: msg.getBytes_asB64(),
    valueMap: (f = msg.getValueMap()) && proto.byhiras.delta.ValueMap.toObject(includeInstance, f),
    valueList: (f = msg.getValueList()) && proto.byhiras.delta.ValueList.toObject(includeInstance, f)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.byhiras.delta.Value}
 */
proto.byhiras.delta.Value.deserializeBinary = function(bytes) {
  var reader = new jspb.BinaryReader(bytes);
  var msg = new proto.byhiras.delta.Value;
  return proto.byhiras.delta.Value.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.byhiras.delta.Value} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.byhiras.delta.Value}
 */
proto.byhiras.delta.Value.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 2:
      var value = /** @type {string} */ (reader.readString());
      msg.setString(value);
      break;
    case 3:
      var value = /** @type {boolean} */ (reader.readBool());
      msg.setBool(value);
      break;
    case 4:
      var value = /** @type {number} */ (reader.readInt32());
      msg.setInt(value);
      break;
    case 5:
      var value = /** @type {number} */ (reader.readInt64());
      msg.setLong(value);
      break;
    case 6:
      var value = /** @type {number} */ (reader.readFloat());
      msg.setFloat(value);
      break;
    case 7:
      var value = /** @type {number} */ (reader.readDouble());
      msg.setDouble(value);
      break;
    case 8:
      var value = /** @type {!Uint8Array} */ (reader.readBytes());
      msg.setBytes(value);
      break;
    case 9:
      var value = new proto.byhiras.delta.ValueMap;
      reader.readMessage(value,proto.byhiras.delta.ValueMap.deserializeBinaryFromReader);
      msg.setValueMap(value);
      break;
    case 10:
      var value = new proto.byhiras.delta.ValueList;
      reader.readMessage(value,proto.byhiras.delta.ValueList.deserializeBinaryFromReader);
      msg.setValueList(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.byhiras.delta.Value.prototype.serializeBinary = function() {
  var writer = new jspb.BinaryWriter();
  proto.byhiras.delta.Value.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.byhiras.delta.Value} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.byhiras.delta.Value.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = /** @type {string} */ (jspb.Message.getField(message, 2));
  if (f != null) {
    writer.writeString(
      2,
      f
    );
  }
  f = /** @type {boolean} */ (jspb.Message.getField(message, 3));
  if (f != null) {
    writer.writeBool(
      3,
      f
    );
  }
  f = /** @type {number} */ (jspb.Message.getField(message, 4));
  if (f != null) {
    writer.writeInt32(
      4,
      f
    );
  }
  f = /** @type {number} */ (jspb.Message.getField(message, 5));
  if (f != null) {
    writer.writeInt64(
      5,
      f
    );
  }
  f = /** @type {number} */ (jspb.Message.getField(message, 6));
  if (f != null) {
    writer.writeFloat(
      6,
      f
    );
  }
  f = /** @type {number} */ (jspb.Message.getField(message, 7));
  if (f != null) {
    writer.writeDouble(
      7,
      f
    );
  }
  f = /** @type {!(string|Uint8Array)} */ (jspb.Message.getField(message, 8));
  if (f != null) {
    writer.writeBytes(
      8,
      f
    );
  }
  f = message.getValueMap();
  if (f != null) {
    writer.writeMessage(
      9,
      f,
      proto.byhiras.delta.ValueMap.serializeBinaryToWriter
    );
  }
  f = message.getValueList();
  if (f != null) {
    writer.writeMessage(
      10,
      f,
      proto.byhiras.delta.ValueList.serializeBinaryToWriter
    );
  }
};


/**
 * optional string string = 2;
 * @return {string}
 */
proto.byhiras.delta.Value.prototype.getString = function() {
  return /** @type {string} */ (jspb.Message.getFieldWithDefault(this, 2, ""));
};


/**
 * @param {string} value
 * @return {!proto.byhiras.delta.Value} returns this
 */
proto.byhiras.delta.Value.prototype.setString = function(value) {
  return jspb.Message.setOneofField(this, 2, proto.byhiras.delta.Value.oneofGroups_[0], value);
};


/**
 * Clears the field making it undefined.
 * @return {!proto.byhiras.delta.Value} returns this
 */
proto.byhiras.delta.Value.prototype.clearString = function() {
  return jspb.Message.setOneofField(this, 2, proto.byhiras.delta.Value.oneofGroups_[0], undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.byhiras.delta.Value.prototype.hasString = function() {
  return jspb.Message.getField(this, 2) != null;
};


/**
 * optional bool bool = 3;
 * @return {boolean}
 */
proto.byhiras.delta.Value.prototype.getBool = function() {
  return /** @type {boolean} */ (jspb.Message.getBooleanFieldWithDefault(this, 3, false));
};


/**
 * @param {boolean} value
 * @return {!proto.byhiras.delta.Value} returns this
 */
proto.byhiras.delta.Value.prototype.setBool = function(value) {
  return jspb.Message.setOneofField(this, 3, proto.byhiras.delta.Value.oneofGroups_[0], value);
};


/**
 * Clears the field making it undefined.
 * @return {!proto.byhiras.delta.Value} returns this
 */
proto.byhiras.delta.Value.prototype.clearBool = function() {
  return jspb.Message.setOneofField(this, 3, proto.byhiras.delta.Value.oneofGroups_[0], undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.byhiras.delta.Value.prototype.hasBool = function() {
  return jspb.Message.getField(this, 3) != null;
};


/**
 * optional int32 int = 4;
 * @return {number}
 */
proto.byhiras.delta.Value.prototype.getInt = function() {
  return /** @type {number} */ (jspb.Message.getFieldWithDefault(this, 4, 0));
};


/**
 * @param {number} value
 * @return {!proto.byhiras.delta.Value} returns this
 */
proto.byhiras.delta.Value.prototype.setInt = function(value) {
  return jspb.Message.setOneofField(this, 4, proto.byhiras.delta.Value.oneofGroups_[0], value);
};


/**
 * Clears the field making it undefined.
 * @return {!proto.byhiras.delta.Value} returns this
 */
proto.byhiras.delta.Value.prototype.clearInt = function() {
  return jspb.Message.setOneofField(this, 4, proto.byhiras.delta.Value.oneofGroups_[0], undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.byhiras.delta.Value.prototype.hasInt = function() {
  return jspb.Message.getField(this, 4) != null;
};


/**
 * optional int64 long = 5;
 * @return {number}
 */
proto.byhiras.delta.Value.prototype.getLong = function() {
  return /** @type {number} */ (jspb.Message.getFieldWithDefault(this, 5, 0));
};


/**
 * @param {number} value
 * @return {!proto.byhiras.delta.Value} returns this
 */
proto.byhiras.delta.Value.prototype.setLong = function(value) {
  return jspb.Message.setOneofField(this, 5, proto.byhiras.delta.Value.oneofGroups_[0], value);
};


/**
 * Clears the field making it undefined.
 * @return {!proto.byhiras.delta.Value} returns this
 */
proto.byhiras.delta.Value.prototype.clearLong = function() {
  return jspb.Message.setOneofField(this, 5, proto.byhiras.delta.Value.oneofGroups_[0], undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.byhiras.delta.Value.prototype.hasLong = function() {
  return jspb.Message.getField(this, 5) != null;
};


/**
 * optional float float = 6;
 * @return {number}
 */
proto.byhiras.delta.Value.prototype.getFloat = function() {
  return /** @type {number} */ (jspb.Message.getFloatingPointFieldWithDefault(this, 6, 0.0));
};


/**
 * @param {number} value
 * @return {!proto.byhiras.delta.Value} returns this
 */
proto.byhiras.delta.Value.prototype.setFloat = function(value) {
  return jspb.Message.setOneofField(this, 6, proto.byhiras.delta.Value.oneofGroups_[0], value);
};


/**
 * Clears the field making it undefined.
 * @return {!proto.byhiras.delta.Value} returns this
 */
proto.byhiras.delta.Value.prototype.clearFloat = function() {
  return jspb.Message.setOneofField(this, 6, proto.byhiras.delta.Value.oneofGroups_[0], undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.byhiras.delta.Value.prototype.hasFloat = function() {
  return jspb.Message.getField(this, 6) != null;
};


/**
 * optional double double = 7;
 * @return {number}
 */
proto.byhiras.delta.Value.prototype.getDouble = function() {
  return /** @type {number} */ (jspb.Message.getFloatingPointFieldWithDefault(this, 7, 0.0));
};


/**
 * @param {number} value
 * @return {!proto.byhiras.delta.Value} returns this
 */
proto.byhiras.delta.Value.prototype.setDouble = function(value) {
  return jspb.Message.setOneofField(this, 7, proto.byhiras.delta.Value.oneofGroups_[0], value);
};


/**
 * Clears the field making it undefined.
 * @return {!proto.byhiras.delta.Value} returns this
 */
proto.byhiras.delta.Value.prototype.clearDouble = function() {
  return jspb.Message.setOneofField(this, 7, proto.byhiras.delta.Value.oneofGroups_[0], undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.byhiras.delta.Value.prototype.hasDouble = function() {
  return jspb.Message.getField(this, 7) != null;
};


/**
 * optional bytes bytes = 8;
 * @return {!(string|Uint8Array)}
 */
proto.byhiras.delta.Value.prototype.getBytes = function() {
  return /** @type {!(string|Uint8Array)} */ (jspb.Message.getFieldWithDefault(this, 8, ""));
};


/**
 * optional bytes bytes = 8;
 * This is a type-conversion wrapper around `getBytes()`
 * @return {string}
 */
proto.byhiras.delta.Value.prototype.getBytes_asB64 = function() {
  return /** @type {string} */ (jspb.Message.bytesAsB64(
      this.getBytes()));
};


/**
 * optional bytes bytes = 8;
 * Note that Uint8Array is not supported on all browsers.
 * @see http://caniuse.com/Uint8Array
 * This is a type-conversion wrapper around `getBytes()`
 * @return {!Uint8Array}
 */
proto.byhiras.delta.Value.prototype.getBytes_asU8 = function() {
  return /** @type {!Uint8Array} */ (jspb.Message.bytesAsU8(
      this.getBytes()));
};


/**
 * @param {!(string|Uint8Array)} value
 * @return {!proto.byhiras.delta.Value} returns this
 */
proto.byhiras.delta.Value.prototype.setBytes = function(value) {
  return jspb.Message.setOneofField(this, 8, proto.byhiras.delta.Value.oneofGroups_[0], value);
};


/**
 * Clears the field making it undefined.
 * @return {!proto.byhiras.delta.Value} returns this
 */
proto.byhiras.delta.Value.prototype.clearBytes = function() {
  return jspb.Message.setOneofField(this, 8, proto.byhiras.delta.Value.oneofGroups_[0], undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.byhiras.delta.Value.prototype.hasBytes = function() {
  return jspb.Message.getField(this, 8) != null;
};


/**
 * optional ValueMap value_map = 9;
 * @return {?proto.byhiras.delta.ValueMap}
 */
proto.byhiras.delta.Value.prototype.getValueMap = function() {
  return /** @type{?proto.byhiras.delta.ValueMap} */ (
    jspb.Message.getWrapperField(this, proto.byhiras.delta.ValueMap, 9));
};


/**
 * @param {?proto.byhiras.delta.ValueMap|undefined} value
 * @return {!proto.byhiras.delta.Value} returns this
*/
proto.byhiras.delta.Value.prototype.setValueMap = function(value) {
  return jspb.Message.setOneofWrapperField(this, 9, proto.byhiras.delta.Value.oneofGroups_[0], value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.byhiras.delta.Value} returns this
 */
proto.byhiras.delta.Value.prototype.clearValueMap = function() {
  return this.setValueMap(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.byhiras.delta.Value.prototype.hasValueMap = function() {
  return jspb.Message.getField(this, 9) != null;
};


/**
 * optional ValueList value_list = 10;
 * @return {?proto.byhiras.delta.ValueList}
 */
proto.byhiras.delta.Value.prototype.getValueList = function() {
  return /** @type{?proto.byhiras.delta.ValueList} */ (
    jspb.Message.getWrapperField(this, proto.byhiras.delta.ValueList, 10));
};


/**
 * @param {?proto.byhiras.delta.ValueList|undefined} value
 * @return {!proto.byhiras.delta.Value} returns this
*/
proto.byhiras.delta.Value.prototype.setValueList = function(value) {
  return jspb.Message.setOneofWrapperField(this, 10, proto.byhiras.delta.Value.oneofGroups_[0], value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.byhiras.delta.Value} returns this
 */
proto.byhiras.delta.Value.prototype.clearValueList = function() {
  return this.setValueList(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.byhiras.delta.Value.prototype.hasValueList = function() {
  return jspb.Message.getField(this, 10) != null;
};





if (jspb.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * Optional fields that are not set will be set to undefined.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     net/proto2/compiler/js/internal/generator.cc#kKeyword.
 * @param {boolean=} opt_includeInstance Deprecated. whether to include the
 *     JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @return {!Object}
 */
proto.byhiras.delta.ValueMap.prototype.toObject = function(opt_includeInstance) {
  return proto.byhiras.delta.ValueMap.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Deprecated. Whether to include
 *     the JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.byhiras.delta.ValueMap} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.byhiras.delta.ValueMap.toObject = function(includeInstance, msg) {
  var f, obj = {
    mapMap: (f = msg.getMapMap()) ? f.toObject(includeInstance, proto.byhiras.delta.Value.toObject) : []
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.byhiras.delta.ValueMap}
 */
proto.byhiras.delta.ValueMap.deserializeBinary = function(bytes) {
  var reader = new jspb.BinaryReader(bytes);
  var msg = new proto.byhiras.delta.ValueMap;
  return proto.byhiras.delta.ValueMap.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.byhiras.delta.ValueMap} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.byhiras.delta.ValueMap}
 */
proto.byhiras.delta.ValueMap.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = msg.getMapMap();
      reader.readMessage(value, function(message, reader) {
        jspb.Map.deserializeBinary(message, reader, jspb.BinaryReader.prototype.readString, jspb.BinaryReader.prototype.readMessage, proto.byhiras.delta.Value.deserializeBinaryFromReader, "", new proto.byhiras.delta.Value());
         });
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.byhiras.delta.ValueMap.prototype.serializeBinary = function() {
  var writer = new jspb.BinaryWriter();
  proto.byhiras.delta.ValueMap.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.byhiras.delta.ValueMap} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.byhiras.delta.ValueMap.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getMapMap(true);
  if (f && f.getLength() > 0) {
    f.serializeBinary(1, writer, jspb.BinaryWriter.prototype.writeString, jspb.BinaryWriter.prototype.writeMessage, proto.byhiras.delta.Value.serializeBinaryToWriter);
  }
};


/**
 * map<string, Value> map = 1;
 * @param {boolean=} opt_noLazyCreate Do not create the map if
 * empty, instead returning `undefined`
 * @return {!jspb.Map<string,!proto.byhiras.delta.Value>}
 */
proto.byhiras.delta.ValueMap.prototype.getMapMap = function(opt_noLazyCreate) {
  return /** @type {!jspb.Map<string,!proto.byhiras.delta.Value>} */ (
      jspb.Message.getMapField(this, 1, opt_noLazyCreate,
      proto.byhiras.delta.Value));
};


/**
 * Clears values from the map. The map will be non-null.
 * @return {!proto.byhiras.delta.ValueMap} returns this
 */
proto.byhiras.delta.ValueMap.prototype.clearMapMap = function() {
  this.getMapMap().clear();
  return this;};



/**
 * List of repeated fields within this message type.
 * @private {!Array<number>}
 * @const
 */
proto.byhiras.delta.ValueList.repeatedFields_ = [1];



if (jspb.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * Optional fields that are not set will be set to undefined.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     net/proto2/compiler/js/internal/generator.cc#kKeyword.
 * @param {boolean=} opt_includeInstance Deprecated. whether to include the
 *     JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @return {!Object}
 */
proto.byhiras.delta.ValueList.prototype.toObject = function(opt_includeInstance) {
  return proto.byhiras.delta.ValueList.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Deprecated. Whether to include
 *     the JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.byhiras.delta.ValueList} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.byhiras.delta.ValueList.toObject = function(includeInstance, msg) {
  var f, obj = {
    elementsList: jspb.Message.toObjectList(msg.getElementsList(),
    proto.byhiras.delta.Value.toObject, includeInstance)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.byhiras.delta.ValueList}
 */
proto.byhiras.delta.ValueList.deserializeBinary = function(bytes) {
  var reader = new jspb.BinaryReader(bytes);
  var msg = new proto.byhiras.delta.ValueList;
  return proto.byhiras.delta.ValueList.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.byhiras.delta.ValueList} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.byhiras.delta.ValueList}
 */
proto.byhiras.delta.ValueList.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = new proto.byhiras.delta.Value;
      reader.readMessage(value,proto.byhiras.delta.Value.deserializeBinaryFromReader);
      msg.addElements(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.byhiras.delta.ValueList.prototype.serializeBinary = function() {
  var writer = new jspb.BinaryWriter();
  proto.byhiras.delta.ValueList.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.byhiras.delta.ValueList} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.byhiras.delta.ValueList.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getElementsList();
  if (f.length > 0) {
    writer.writeRepeatedMessage(
      1,
      f,
      proto.byhiras.delta.Value.serializeBinaryToWriter
    );
  }
};


/**
 * repeated Value elements = 1;
 * @return {!Array<!proto.byhiras.delta.Value>}
 */
proto.byhiras.delta.ValueList.prototype.getElementsList = function() {
  return /** @type{!Array<!proto.byhiras.delta.Value>} */ (
    jspb.Message.getRepeatedWrapperField(this, proto.byhiras.delta.Value, 1));
};


/**
 * @param {!Array<!proto.byhiras.delta.Value>} value
 * @return {!proto.byhiras.delta.ValueList} returns this
*/
proto.byhiras.delta.ValueList.prototype.setElementsList = function(value) {
  return jspb.Message.setRepeatedWrapperField(this, 1, value);
};


/**
 * @param {!proto.byhiras.delta.Value=} opt_value
 * @param {number=} opt_index
 * @return {!proto.byhiras.delta.Value}
 */
proto.byhiras.delta.ValueList.prototype.addElements = function(opt_value, opt_index) {
  return jspb.Message.addToRepeatedWrapperField(this, 1, opt_value, proto.byhiras.delta.Value, opt_index);
};


/**
 * Clears the list making it empty but non-null.
 * @return {!proto.byhiras.delta.ValueList} returns this
 */
proto.byhiras.delta.ValueList.prototype.clearElementsList = function() {
  return this.setElementsList([]);
};





if (jspb.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * Optional fields that are not set will be set to undefined.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     net/proto2/compiler/js/internal/generator.cc#kKeyword.
 * @param {boolean=} opt_includeInstance Deprecated. whether to include the
 *     JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @return {!Object}
 */
proto.byhiras.delta.JsonPatchOp.prototype.toObject = function(opt_includeInstance) {
  return proto.byhiras.delta.JsonPatchOp.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Deprecated. Whether to include
 *     the JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.byhiras.delta.JsonPatchOp} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.byhiras.delta.JsonPatchOp.toObject = function(includeInstance, msg) {
  var f, obj = {
    op: jspb.Message.getFieldWithDefault(msg, 1, 0),
    path: jspb.Message.getFieldWithDefault(msg, 2, ""),
    value: (f = msg.getValue()) && proto.byhiras.delta.Value.toObject(includeInstance, f),
    fromPath: (f = msg.getFromPath()) && google_protobuf_wrappers_pb.StringValue.toObject(includeInstance, f),
    fromValue: (f = msg.getFromValue()) && proto.byhiras.delta.Value.toObject(includeInstance, f)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.byhiras.delta.JsonPatchOp}
 */
proto.byhiras.delta.JsonPatchOp.deserializeBinary = function(bytes) {
  var reader = new jspb.BinaryReader(bytes);
  var msg = new proto.byhiras.delta.JsonPatchOp;
  return proto.byhiras.delta.JsonPatchOp.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.byhiras.delta.JsonPatchOp} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.byhiras.delta.JsonPatchOp}
 */
proto.byhiras.delta.JsonPatchOp.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = /** @type {!proto.byhiras.delta.Op} */ (reader.readEnum());
      msg.setOp(value);
      break;
    case 2:
      var value = /** @type {string} */ (reader.readString());
      msg.setPath(value);
      break;
    case 3:
      var value = new proto.byhiras.delta.Value;
      reader.readMessage(value,proto.byhiras.delta.Value.deserializeBinaryFromReader);
      msg.setValue(value);
      break;
    case 4:
      var value = new google_protobuf_wrappers_pb.StringValue;
      reader.readMessage(value,google_protobuf_wrappers_pb.StringValue.deserializeBinaryFromReader);
      msg.setFromPath(value);
      break;
    case 5:
      var value = new proto.byhiras.delta.Value;
      reader.readMessage(value,proto.byhiras.delta.Value.deserializeBinaryFromReader);
      msg.setFromValue(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.byhiras.delta.JsonPatchOp.prototype.serializeBinary = function() {
  var writer = new jspb.BinaryWriter();
  proto.byhiras.delta.JsonPatchOp.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.byhiras.delta.JsonPatchOp} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.byhiras.delta.JsonPatchOp.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getOp();
  if (f !== 0.0) {
    writer.writeEnum(
      1,
      f
    );
  }
  f = message.getPath();
  if (f.length > 0) {
    writer.writeString(
      2,
      f
    );
  }
  f = message.getValue();
  if (f != null) {
    writer.writeMessage(
      3,
      f,
      proto.byhiras.delta.Value.serializeBinaryToWriter
    );
  }
  f = message.getFromPath();
  if (f != null) {
    writer.writeMessage(
      4,
      f,
      google_protobuf_wrappers_pb.StringValue.serializeBinaryToWriter
    );
  }
  f = message.getFromValue();
  if (f != null) {
    writer.writeMessage(
      5,
      f,
      proto.byhiras.delta.Value.serializeBinaryToWriter
    );
  }
};


/**
 * optional Op op = 1;
 * @return {!proto.byhiras.delta.Op}
 */
proto.byhiras.delta.JsonPatchOp.prototype.getOp = function() {
  return /** @type {!proto.byhiras.delta.Op} */ (jspb.Message.getFieldWithDefault(this, 1, 0));
};


/**
 * @param {!proto.byhiras.delta.Op} value
 * @return {!proto.byhiras.delta.JsonPatchOp} returns this
 */
proto.byhiras.delta.JsonPatchOp.prototype.setOp = function(value) {
  return jspb.Message.setProto3EnumField(this, 1, value);
};


/**
 * optional string path = 2;
 * @return {string}
 */
proto.byhiras.delta.JsonPatchOp.prototype.getPath = function() {
  return /** @type {string} */ (jspb.Message.getFieldWithDefault(this, 2, ""));
};


/**
 * @param {string} value
 * @return {!proto.byhiras.delta.JsonPatchOp} returns this
 */
proto.byhiras.delta.JsonPatchOp.prototype.setPath = function(value) {
  return jspb.Message.setProto3StringField(this, 2, value);
};


/**
 * optional Value value = 3;
 * @return {?proto.byhiras.delta.Value}
 */
proto.byhiras.delta.JsonPatchOp.prototype.getValue = function() {
  return /** @type{?proto.byhiras.delta.Value} */ (
    jspb.Message.getWrapperField(this, proto.byhiras.delta.Value, 3));
};


/**
 * @param {?proto.byhiras.delta.Value|undefined} value
 * @return {!proto.byhiras.delta.JsonPatchOp} returns this
*/
proto.byhiras.delta.JsonPatchOp.prototype.setValue = function(value) {
  return jspb.Message.setWrapperField(this, 3, value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.byhiras.delta.JsonPatchOp} returns this
 */
proto.byhiras.delta.JsonPatchOp.prototype.clearValue = function() {
  return this.setValue(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.byhiras.delta.JsonPatchOp.prototype.hasValue = function() {
  return jspb.Message.getField(this, 3) != null;
};


/**
 * optional google.protobuf.StringValue from_path = 4;
 * @return {?proto.google.protobuf.StringValue}
 */
proto.byhiras.delta.JsonPatchOp.prototype.getFromPath = function() {
  return /** @type{?proto.google.protobuf.StringValue} */ (
    jspb.Message.getWrapperField(this, google_protobuf_wrappers_pb.StringValue, 4));
};


/**
 * @param {?proto.google.protobuf.StringValue|undefined} value
 * @return {!proto.byhiras.delta.JsonPatchOp} returns this
*/
proto.byhiras.delta.JsonPatchOp.prototype.setFromPath = function(value) {
  return jspb.Message.setWrapperField(this, 4, value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.byhiras.delta.JsonPatchOp} returns this
 */
proto.byhiras.delta.JsonPatchOp.prototype.clearFromPath = function() {
  return this.setFromPath(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.byhiras.delta.JsonPatchOp.prototype.hasFromPath = function() {
  return jspb.Message.getField(this, 4) != null;
};


/**
 * optional Value from_value = 5;
 * @return {?proto.byhiras.delta.Value}
 */
proto.byhiras.delta.JsonPatchOp.prototype.getFromValue = function() {
  return /** @type{?proto.byhiras.delta.Value} */ (
    jspb.Message.getWrapperField(this, proto.byhiras.delta.Value, 5));
};


/**
 * @param {?proto.byhiras.delta.Value|undefined} value
 * @return {!proto.byhiras.delta.JsonPatchOp} returns this
*/
proto.byhiras.delta.JsonPatchOp.prototype.setFromValue = function(value) {
  return jspb.Message.setWrapperField(this, 5, value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.byhiras.delta.JsonPatchOp} returns this
 */
proto.byhiras.delta.JsonPatchOp.prototype.clearFromValue = function() {
  return this.setFromValue(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.byhiras.delta.JsonPatchOp.prototype.hasFromValue = function() {
  return jspb.Message.getField(this, 5) != null;
};



/**
 * List of repeated fields within this message type.
 * @private {!Array<number>}
 * @const
 */
proto.byhiras.delta.PatchEvent.repeatedFields_ = [3];



if (jspb.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * Optional fields that are not set will be set to undefined.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     net/proto2/compiler/js/internal/generator.cc#kKeyword.
 * @param {boolean=} opt_includeInstance Deprecated. whether to include the
 *     JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @return {!Object}
 */
proto.byhiras.delta.PatchEvent.prototype.toObject = function(opt_includeInstance) {
  return proto.byhiras.delta.PatchEvent.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Deprecated. Whether to include
 *     the JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.byhiras.delta.PatchEvent} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.byhiras.delta.PatchEvent.toObject = function(includeInstance, msg) {
  var f, obj = {
    identity: (f = msg.getIdentity()) && byhiras_identity_identity_pb.Identity.toObject(includeInstance, f),
    targetidentity: (f = msg.getTargetidentity()) && byhiras_identity_identity_pb.Identity.toObject(includeInstance, f),
    patchOpsList: jspb.Message.toObjectList(msg.getPatchOpsList(),
    proto.byhiras.delta.JsonPatchOp.toObject, includeInstance),
    committerUsername: jspb.Message.getFieldWithDefault(msg, 4, ""),
    dateTime: jspb.Message.getFieldWithDefault(msg, 5, 0),
    dateTimeOld: jspb.Message.getFieldWithDefault(msg, 55, 0)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.byhiras.delta.PatchEvent}
 */
proto.byhiras.delta.PatchEvent.deserializeBinary = function(bytes) {
  var reader = new jspb.BinaryReader(bytes);
  var msg = new proto.byhiras.delta.PatchEvent;
  return proto.byhiras.delta.PatchEvent.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.byhiras.delta.PatchEvent} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.byhiras.delta.PatchEvent}
 */
proto.byhiras.delta.PatchEvent.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = new byhiras_identity_identity_pb.Identity;
      reader.readMessage(value,byhiras_identity_identity_pb.Identity.deserializeBinaryFromReader);
      msg.setIdentity(value);
      break;
    case 2:
      var value = new byhiras_identity_identity_pb.Identity;
      reader.readMessage(value,byhiras_identity_identity_pb.Identity.deserializeBinaryFromReader);
      msg.setTargetidentity(value);
      break;
    case 3:
      var value = new proto.byhiras.delta.JsonPatchOp;
      reader.readMessage(value,proto.byhiras.delta.JsonPatchOp.deserializeBinaryFromReader);
      msg.addPatchOps(value);
      break;
    case 4:
      var value = /** @type {string} */ (reader.readString());
      msg.setCommitterUsername(value);
      break;
    case 5:
      var value = /** @type {number} */ (reader.readInt64());
      msg.setDateTime(value);
      break;
    case 55:
      var value = /** @type {number} */ (reader.readInt64());
      msg.setDateTimeOld(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.byhiras.delta.PatchEvent.prototype.serializeBinary = function() {
  var writer = new jspb.BinaryWriter();
  proto.byhiras.delta.PatchEvent.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.byhiras.delta.PatchEvent} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.byhiras.delta.PatchEvent.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getIdentity();
  if (f != null) {
    writer.writeMessage(
      1,
      f,
      byhiras_identity_identity_pb.Identity.serializeBinaryToWriter
    );
  }
  f = message.getTargetidentity();
  if (f != null) {
    writer.writeMessage(
      2,
      f,
      byhiras_identity_identity_pb.Identity.serializeBinaryToWriter
    );
  }
  f = message.getPatchOpsList();
  if (f.length > 0) {
    writer.writeRepeatedMessage(
      3,
      f,
      proto.byhiras.delta.JsonPatchOp.serializeBinaryToWriter
    );
  }
  f = message.getCommitterUsername();
  if (f.length > 0) {
    writer.writeString(
      4,
      f
    );
  }
  f = message.getDateTime();
  if (f !== 0) {
    writer.writeInt64(
      5,
      f
    );
  }
  f = message.getDateTimeOld();
  if (f !== 0) {
    writer.writeInt64(
      55,
      f
    );
  }
};


/**
 * optional byhiras.identity.Identity identity = 1;
 * @return {?proto.byhiras.identity.Identity}
 */
proto.byhiras.delta.PatchEvent.prototype.getIdentity = function() {
  return /** @type{?proto.byhiras.identity.Identity} */ (
    jspb.Message.getWrapperField(this, byhiras_identity_identity_pb.Identity, 1));
};


/**
 * @param {?proto.byhiras.identity.Identity|undefined} value
 * @return {!proto.byhiras.delta.PatchEvent} returns this
*/
proto.byhiras.delta.PatchEvent.prototype.setIdentity = function(value) {
  return jspb.Message.setWrapperField(this, 1, value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.byhiras.delta.PatchEvent} returns this
 */
proto.byhiras.delta.PatchEvent.prototype.clearIdentity = function() {
  return this.setIdentity(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.byhiras.delta.PatchEvent.prototype.hasIdentity = function() {
  return jspb.Message.getField(this, 1) != null;
};


/**
 * optional byhiras.identity.Identity targetIdentity = 2;
 * @return {?proto.byhiras.identity.Identity}
 */
proto.byhiras.delta.PatchEvent.prototype.getTargetidentity = function() {
  return /** @type{?proto.byhiras.identity.Identity} */ (
    jspb.Message.getWrapperField(this, byhiras_identity_identity_pb.Identity, 2));
};


/**
 * @param {?proto.byhiras.identity.Identity|undefined} value
 * @return {!proto.byhiras.delta.PatchEvent} returns this
*/
proto.byhiras.delta.PatchEvent.prototype.setTargetidentity = function(value) {
  return jspb.Message.setWrapperField(this, 2, value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.byhiras.delta.PatchEvent} returns this
 */
proto.byhiras.delta.PatchEvent.prototype.clearTargetidentity = function() {
  return this.setTargetidentity(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.byhiras.delta.PatchEvent.prototype.hasTargetidentity = function() {
  return jspb.Message.getField(this, 2) != null;
};


/**
 * repeated JsonPatchOp patch_ops = 3;
 * @return {!Array<!proto.byhiras.delta.JsonPatchOp>}
 */
proto.byhiras.delta.PatchEvent.prototype.getPatchOpsList = function() {
  return /** @type{!Array<!proto.byhiras.delta.JsonPatchOp>} */ (
    jspb.Message.getRepeatedWrapperField(this, proto.byhiras.delta.JsonPatchOp, 3));
};


/**
 * @param {!Array<!proto.byhiras.delta.JsonPatchOp>} value
 * @return {!proto.byhiras.delta.PatchEvent} returns this
*/
proto.byhiras.delta.PatchEvent.prototype.setPatchOpsList = function(value) {
  return jspb.Message.setRepeatedWrapperField(this, 3, value);
};


/**
 * @param {!proto.byhiras.delta.JsonPatchOp=} opt_value
 * @param {number=} opt_index
 * @return {!proto.byhiras.delta.JsonPatchOp}
 */
proto.byhiras.delta.PatchEvent.prototype.addPatchOps = function(opt_value, opt_index) {
  return jspb.Message.addToRepeatedWrapperField(this, 3, opt_value, proto.byhiras.delta.JsonPatchOp, opt_index);
};


/**
 * Clears the list making it empty but non-null.
 * @return {!proto.byhiras.delta.PatchEvent} returns this
 */
proto.byhiras.delta.PatchEvent.prototype.clearPatchOpsList = function() {
  return this.setPatchOpsList([]);
};


/**
 * optional string committer_username = 4;
 * @return {string}
 */
proto.byhiras.delta.PatchEvent.prototype.getCommitterUsername = function() {
  return /** @type {string} */ (jspb.Message.getFieldWithDefault(this, 4, ""));
};


/**
 * @param {string} value
 * @return {!proto.byhiras.delta.PatchEvent} returns this
 */
proto.byhiras.delta.PatchEvent.prototype.setCommitterUsername = function(value) {
  return jspb.Message.setProto3StringField(this, 4, value);
};


/**
 * optional int64 date_time = 5;
 * @return {number}
 */
proto.byhiras.delta.PatchEvent.prototype.getDateTime = function() {
  return /** @type {number} */ (jspb.Message.getFieldWithDefault(this, 5, 0));
};


/**
 * @param {number} value
 * @return {!proto.byhiras.delta.PatchEvent} returns this
 */
proto.byhiras.delta.PatchEvent.prototype.setDateTime = function(value) {
  return jspb.Message.setProto3IntField(this, 5, value);
};


/**
 * optional int64 date_time_old = 55;
 * @return {number}
 */
proto.byhiras.delta.PatchEvent.prototype.getDateTimeOld = function() {
  return /** @type {number} */ (jspb.Message.getFieldWithDefault(this, 55, 0));
};


/**
 * @param {number} value
 * @return {!proto.byhiras.delta.PatchEvent} returns this
 */
proto.byhiras.delta.PatchEvent.prototype.setDateTimeOld = function(value) {
  return jspb.Message.setProto3IntField(this, 55, value);
};



/**
 * List of repeated fields within this message type.
 * @private {!Array<number>}
 * @const
 */
proto.byhiras.delta.PatchEventRequest.repeatedFields_ = [3];

/**
 * Oneof group definitions for this message. Each group defines the field
 * numbers belonging to that group. When of these fields' value is set, all
 * other fields in the group are cleared. During deserialization, if multiple
 * fields are encountered for a group, only the last value seen will be kept.
 * @private {!Array<!Array<number>>}
 * @const
 */
proto.byhiras.delta.PatchEventRequest.oneofGroups_ = [[1,2]];

/**
 * @enum {number}
 */
proto.byhiras.delta.PatchEventRequest.TargetCase = {
  TARGET_NOT_SET: 0,
  TARGETIDENTITY: 1,
  TARGETENTITYTYPE: 2
};

/**
 * @return {proto.byhiras.delta.PatchEventRequest.TargetCase}
 */
proto.byhiras.delta.PatchEventRequest.prototype.getTargetCase = function() {
  return /** @type {proto.byhiras.delta.PatchEventRequest.TargetCase} */(jspb.Message.computeOneofCase(this, proto.byhiras.delta.PatchEventRequest.oneofGroups_[0]));
};



if (jspb.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * Optional fields that are not set will be set to undefined.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     net/proto2/compiler/js/internal/generator.cc#kKeyword.
 * @param {boolean=} opt_includeInstance Deprecated. whether to include the
 *     JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @return {!Object}
 */
proto.byhiras.delta.PatchEventRequest.prototype.toObject = function(opt_includeInstance) {
  return proto.byhiras.delta.PatchEventRequest.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Deprecated. Whether to include
 *     the JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.byhiras.delta.PatchEventRequest} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.byhiras.delta.PatchEventRequest.toObject = function(includeInstance, msg) {
  var f, obj = {
    targetidentity: (f = msg.getTargetidentity()) && byhiras_identity_identity_pb.Identity.toObject(includeInstance, f),
    targetentitytype: jspb.Message.getFieldWithDefault(msg, 2, 0),
    patchOpsList: jspb.Message.toObjectList(msg.getPatchOpsList(),
    proto.byhiras.delta.JsonPatchOp.toObject, includeInstance)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.byhiras.delta.PatchEventRequest}
 */
proto.byhiras.delta.PatchEventRequest.deserializeBinary = function(bytes) {
  var reader = new jspb.BinaryReader(bytes);
  var msg = new proto.byhiras.delta.PatchEventRequest;
  return proto.byhiras.delta.PatchEventRequest.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.byhiras.delta.PatchEventRequest} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.byhiras.delta.PatchEventRequest}
 */
proto.byhiras.delta.PatchEventRequest.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = new byhiras_identity_identity_pb.Identity;
      reader.readMessage(value,byhiras_identity_identity_pb.Identity.deserializeBinaryFromReader);
      msg.setTargetidentity(value);
      break;
    case 2:
      var value = /** @type {!proto.byhiras.identity.EntityType} */ (reader.readEnum());
      msg.setTargetentitytype(value);
      break;
    case 3:
      var value = new proto.byhiras.delta.JsonPatchOp;
      reader.readMessage(value,proto.byhiras.delta.JsonPatchOp.deserializeBinaryFromReader);
      msg.addPatchOps(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.byhiras.delta.PatchEventRequest.prototype.serializeBinary = function() {
  var writer = new jspb.BinaryWriter();
  proto.byhiras.delta.PatchEventRequest.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.byhiras.delta.PatchEventRequest} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.byhiras.delta.PatchEventRequest.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getTargetidentity();
  if (f != null) {
    writer.writeMessage(
      1,
      f,
      byhiras_identity_identity_pb.Identity.serializeBinaryToWriter
    );
  }
  f = /** @type {!proto.byhiras.identity.EntityType} */ (jspb.Message.getField(message, 2));
  if (f != null) {
    writer.writeEnum(
      2,
      f
    );
  }
  f = message.getPatchOpsList();
  if (f.length > 0) {
    writer.writeRepeatedMessage(
      3,
      f,
      proto.byhiras.delta.JsonPatchOp.serializeBinaryToWriter
    );
  }
};


/**
 * optional byhiras.identity.Identity targetIdentity = 1;
 * @return {?proto.byhiras.identity.Identity}
 */
proto.byhiras.delta.PatchEventRequest.prototype.getTargetidentity = function() {
  return /** @type{?proto.byhiras.identity.Identity} */ (
    jspb.Message.getWrapperField(this, byhiras_identity_identity_pb.Identity, 1));
};


/**
 * @param {?proto.byhiras.identity.Identity|undefined} value
 * @return {!proto.byhiras.delta.PatchEventRequest} returns this
*/
proto.byhiras.delta.PatchEventRequest.prototype.setTargetidentity = function(value) {
  return jspb.Message.setOneofWrapperField(this, 1, proto.byhiras.delta.PatchEventRequest.oneofGroups_[0], value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.byhiras.delta.PatchEventRequest} returns this
 */
proto.byhiras.delta.PatchEventRequest.prototype.clearTargetidentity = function() {
  return this.setTargetidentity(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.byhiras.delta.PatchEventRequest.prototype.hasTargetidentity = function() {
  return jspb.Message.getField(this, 1) != null;
};


/**
 * optional byhiras.identity.EntityType targetEntityType = 2;
 * @return {!proto.byhiras.identity.EntityType}
 */
proto.byhiras.delta.PatchEventRequest.prototype.getTargetentitytype = function() {
  return /** @type {!proto.byhiras.identity.EntityType} */ (jspb.Message.getFieldWithDefault(this, 2, 0));
};


/**
 * @param {!proto.byhiras.identity.EntityType} value
 * @return {!proto.byhiras.delta.PatchEventRequest} returns this
 */
proto.byhiras.delta.PatchEventRequest.prototype.setTargetentitytype = function(value) {
  return jspb.Message.setOneofField(this, 2, proto.byhiras.delta.PatchEventRequest.oneofGroups_[0], value);
};


/**
 * Clears the field making it undefined.
 * @return {!proto.byhiras.delta.PatchEventRequest} returns this
 */
proto.byhiras.delta.PatchEventRequest.prototype.clearTargetentitytype = function() {
  return jspb.Message.setOneofField(this, 2, proto.byhiras.delta.PatchEventRequest.oneofGroups_[0], undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.byhiras.delta.PatchEventRequest.prototype.hasTargetentitytype = function() {
  return jspb.Message.getField(this, 2) != null;
};


/**
 * repeated JsonPatchOp patch_ops = 3;
 * @return {!Array<!proto.byhiras.delta.JsonPatchOp>}
 */
proto.byhiras.delta.PatchEventRequest.prototype.getPatchOpsList = function() {
  return /** @type{!Array<!proto.byhiras.delta.JsonPatchOp>} */ (
    jspb.Message.getRepeatedWrapperField(this, proto.byhiras.delta.JsonPatchOp, 3));
};


/**
 * @param {!Array<!proto.byhiras.delta.JsonPatchOp>} value
 * @return {!proto.byhiras.delta.PatchEventRequest} returns this
*/
proto.byhiras.delta.PatchEventRequest.prototype.setPatchOpsList = function(value) {
  return jspb.Message.setRepeatedWrapperField(this, 3, value);
};


/**
 * @param {!proto.byhiras.delta.JsonPatchOp=} opt_value
 * @param {number=} opt_index
 * @return {!proto.byhiras.delta.JsonPatchOp}
 */
proto.byhiras.delta.PatchEventRequest.prototype.addPatchOps = function(opt_value, opt_index) {
  return jspb.Message.addToRepeatedWrapperField(this, 3, opt_value, proto.byhiras.delta.JsonPatchOp, opt_index);
};


/**
 * Clears the list making it empty but non-null.
 * @return {!proto.byhiras.delta.PatchEventRequest} returns this
 */
proto.byhiras.delta.PatchEventRequest.prototype.clearPatchOpsList = function() {
  return this.setPatchOpsList([]);
};



/**
 * List of repeated fields within this message type.
 * @private {!Array<number>}
 * @const
 */
proto.byhiras.delta.JsonPatchRequest.repeatedFields_ = [2];



if (jspb.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * Optional fields that are not set will be set to undefined.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     net/proto2/compiler/js/internal/generator.cc#kKeyword.
 * @param {boolean=} opt_includeInstance Deprecated. whether to include the
 *     JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @return {!Object}
 */
proto.byhiras.delta.JsonPatchRequest.prototype.toObject = function(opt_includeInstance) {
  return proto.byhiras.delta.JsonPatchRequest.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Deprecated. Whether to include
 *     the JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.byhiras.delta.JsonPatchRequest} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.byhiras.delta.JsonPatchRequest.toObject = function(includeInstance, msg) {
  var f, obj = {
    patch: (f = msg.getPatch()) && proto.byhiras.delta.PatchEvent.toObject(includeInstance, f),
    patchesList: jspb.Message.toObjectList(msg.getPatchesList(),
    proto.byhiras.delta.PatchEventRequest.toObject, includeInstance)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.byhiras.delta.JsonPatchRequest}
 */
proto.byhiras.delta.JsonPatchRequest.deserializeBinary = function(bytes) {
  var reader = new jspb.BinaryReader(bytes);
  var msg = new proto.byhiras.delta.JsonPatchRequest;
  return proto.byhiras.delta.JsonPatchRequest.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.byhiras.delta.JsonPatchRequest} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.byhiras.delta.JsonPatchRequest}
 */
proto.byhiras.delta.JsonPatchRequest.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = new proto.byhiras.delta.PatchEvent;
      reader.readMessage(value,proto.byhiras.delta.PatchEvent.deserializeBinaryFromReader);
      msg.setPatch(value);
      break;
    case 2:
      var value = new proto.byhiras.delta.PatchEventRequest;
      reader.readMessage(value,proto.byhiras.delta.PatchEventRequest.deserializeBinaryFromReader);
      msg.addPatches(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.byhiras.delta.JsonPatchRequest.prototype.serializeBinary = function() {
  var writer = new jspb.BinaryWriter();
  proto.byhiras.delta.JsonPatchRequest.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.byhiras.delta.JsonPatchRequest} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.byhiras.delta.JsonPatchRequest.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getPatch();
  if (f != null) {
    writer.writeMessage(
      1,
      f,
      proto.byhiras.delta.PatchEvent.serializeBinaryToWriter
    );
  }
  f = message.getPatchesList();
  if (f.length > 0) {
    writer.writeRepeatedMessage(
      2,
      f,
      proto.byhiras.delta.PatchEventRequest.serializeBinaryToWriter
    );
  }
};


/**
 * optional PatchEvent patch = 1;
 * @return {?proto.byhiras.delta.PatchEvent}
 */
proto.byhiras.delta.JsonPatchRequest.prototype.getPatch = function() {
  return /** @type{?proto.byhiras.delta.PatchEvent} */ (
    jspb.Message.getWrapperField(this, proto.byhiras.delta.PatchEvent, 1));
};


/**
 * @param {?proto.byhiras.delta.PatchEvent|undefined} value
 * @return {!proto.byhiras.delta.JsonPatchRequest} returns this
*/
proto.byhiras.delta.JsonPatchRequest.prototype.setPatch = function(value) {
  return jspb.Message.setWrapperField(this, 1, value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.byhiras.delta.JsonPatchRequest} returns this
 */
proto.byhiras.delta.JsonPatchRequest.prototype.clearPatch = function() {
  return this.setPatch(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.byhiras.delta.JsonPatchRequest.prototype.hasPatch = function() {
  return jspb.Message.getField(this, 1) != null;
};


/**
 * repeated PatchEventRequest patches = 2;
 * @return {!Array<!proto.byhiras.delta.PatchEventRequest>}
 */
proto.byhiras.delta.JsonPatchRequest.prototype.getPatchesList = function() {
  return /** @type{!Array<!proto.byhiras.delta.PatchEventRequest>} */ (
    jspb.Message.getRepeatedWrapperField(this, proto.byhiras.delta.PatchEventRequest, 2));
};


/**
 * @param {!Array<!proto.byhiras.delta.PatchEventRequest>} value
 * @return {!proto.byhiras.delta.JsonPatchRequest} returns this
*/
proto.byhiras.delta.JsonPatchRequest.prototype.setPatchesList = function(value) {
  return jspb.Message.setRepeatedWrapperField(this, 2, value);
};


/**
 * @param {!proto.byhiras.delta.PatchEventRequest=} opt_value
 * @param {number=} opt_index
 * @return {!proto.byhiras.delta.PatchEventRequest}
 */
proto.byhiras.delta.JsonPatchRequest.prototype.addPatches = function(opt_value, opt_index) {
  return jspb.Message.addToRepeatedWrapperField(this, 2, opt_value, proto.byhiras.delta.PatchEventRequest, opt_index);
};


/**
 * Clears the list making it empty but non-null.
 * @return {!proto.byhiras.delta.JsonPatchRequest} returns this
 */
proto.byhiras.delta.JsonPatchRequest.prototype.clearPatchesList = function() {
  return this.setPatchesList([]);
};


/**
 * @enum {number}
 */
proto.byhiras.delta.Op = {
  ADD: 0,
  REMOVE: 1,
  REPLACE: 2,
  COPY: 3,
  MOVE: 4,
  TEST: 5,
  SET_ADD: 6,
  SET_REMOVE: 7
};

goog.object.extend(exports, proto.byhiras.delta);
